{
     Apophysis Copyright (C) 2001-2004 Mark Townsend
     Apophysis Copyright (C) 2005-2006 Ronald Hordijk, Piotr Borys, Peter Sdobnov
     Apophysis Copyright (C) 2007-2008 Piotr Borys, Peter Sdobnov
     
     Apophysis "3D hack" Copyright (C) 2007-2008 Peter Sdobnov
     Apophysis "7X" Copyright (C) 2009-2010 Georg Kiehne
     Apophysis AV "Phoenix Edition" Copyright (C) 2021 Alice V. Koryagina

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit varUnpolar;

interface

uses
  BaseVariation, XFormMan;

type
  TVariationUnpolar = class(TBaseVariation)
  private
	vvar_pi: double;
  public
    constructor Create;

    class function GetName: string; override;
    class function GetInstance: TBaseVariation; override;

    procedure Prepare; override;
	procedure CalcFunction; override;
  end;

implementation

uses
  Math;


///////////////////////////////////////////////////////////////////////////////
procedure TVariationUnpolar.Prepare;
begin
	vvar_pi := vvar / pi * 0.5;
end;

procedure TVariationUnpolar.CalcFunction;
var
  r, sn, cn: double;
begin
  r := exp(FTy^);
  sincos(FTx^, sn, cn);

  FPx^ := FPx^ + vvar_pi * r * sn;
  FPy^ := FPy^ + vvar_pi * r * cn;
  // FPz^ := FPz^ + vvar * FTz^;
end;

///////////////////////////////////////////////////////////////////////////////
constructor TVariationUnpolar.Create;
begin
end;

///////////////////////////////////////////////////////////////////////////////
class function TVariationUnpolar.GetInstance: TBaseVariation;
begin
  Result := TVariationUnpolar.Create;
end;

///////////////////////////////////////////////////////////////////////////////
class function TVariationUnpolar.GetName: string;
begin
  Result := 'unpolar';
end;

///////////////////////////////////////////////////////////////////////////////
initialization
  RegisterVariation(TVariationClassLoader.Create(TVariationUnpolar), false, false);
end.
